﻿        DEVICE ZXSPECTRUM128
		ORG #6000
begin
		ld sp, $ : xor a : out (#fe), a
	
		; чистим память
		ld hl, PL_BUF, bc, #e000 - PL_BUF - 1 : call cleanup
		; в de теперь #e000 - для переноса шрифта
		
		; генерируем плавающие плашки
		; переносим шрифт для модификации
		ld hl, #3d00, bc, #300 : ldir

		; X -> Ж
		ld hl, #e1c1, bc,#3c6b : ld (hl), c
		inc hl : ld (hl), c
		inc hl : ld (hl), b
		inc hl : ld (hl), b
		inc hl : ld (hl), c
		inc hl : ld (hl), c
		
		ld bc, #423e
		ld de, #407e
		
		; U -> Л
		ld l, #a9 : ld (hl), c
		ld l, #ae : ld (hl), b

		; B -> Б
		ld l, #11 : ld (hl), e
		inc hl : ld (hl), d

		; V -> Д & 6 -> Ь
		ld l, #b1 : ld (hl), c
		dec h : ld (hl), d : inc h
		
		set 2, l ; ld hl, #e1b5
		ld (hl), b
		inc hl : ld (hl), e
	
		dec h : ld (hl), #7c
		
		; начинаем заполнять буфер - 8 фаз
		ld a, #01
		ld iy, PL_BUF
_gP00	
		ld (_gP011 + 1), a
		push af

		ld de, TEXT1
		ld b, 18 ; 18 букв (считая пробел между словами)
		
_gP01	push bc, iy
		; ищем букву в шрифте
		ld a, (de), l, a, h,#00, bc,#e000
		add hl, hl : add hl, hl : add hl, hl : add hl, bc
		inc de
		
		ld b, #08

_gP011	ld c, #00 ; на сколько сдвигаем в знакоместе
		ld a, (hl) 
		rla 
		cp #d6 : jr z, $+3	; пропускаем "ж"
		or (hl) ; do bold
				
1		rra : rr (iy + 1) 
		dec c : jr nz, 1b
		or (iy + 0) : ld (iy + 0), a
		
        inc yh : inc hl
        djnz _gP011
		
		pop iy, bc
		inc iy
        djnz _gP01
		
		ld de, 14 : add iy, de

		pop af
		inc a : cp #09 : jr nz, _gP00
		
		; генерируем синусы
		; b уже равно 0
		ld c, #23, de, SINUS_TBL : push de : call SINMAKE
		; b уже равно 0
		ld c, #1d : call SINMAKE
		
		; generate sinus curse 1&2
		; e уже равно 0
		; l уже равно 0
		pop bc, ; SINUS_TBL
		ld h, CURSE1/256
		ld d, CURSE2/256
_gc1	push bc
		
		ld a, (bc)
		push af : sra a : sra a : sra a : add 60 : ld (de), a : inc d : pop af
		sla a : add 74 : ld (de), a : inc de : dec d
		add 23 : ld (hl), a : inc h

		ld a, c : rla : rla : rla : ld c, a
		ld a, (bc)
		rla : add 112
		ld (hl), a
		inc hl : dec h
		
		pop bc
		dec c : jr nz, _gc1

		; test curse
		/*
		ei : ld a, #10: out (#fd), a ; 7 страница
		ld hl, CURSE2
_t		halt
		ld d, (hl) : inc hl : ld e, (hl) : inc hl
		push hl : call GET_ADR : or (hl) : ld (hl), a : pop hl
		ld a, h : cp (CURSE2 / 256) + 2 : jr nz, _t
		*/

		
/*		
		ld hl, #3330, d, #24 : call makeTrees
		ld hl, #3e90, d, #28 : call makeTrees
		ld hl, #40e0, d, #1c : call makeTrees
*/		

		; готовим атрибуты 
		ld a, #1f : out (#fd), a : call prepareAttr
		ld a, #1d : out (#fd), a : call prepareAttr

		ld hl,IM2,(#5eff),HL, A,#5e, i,a : im 2 : ei
mainLoop1
		; h - угол, l - x, d - выстота
		ld hl, #3330, d, #24 : call makeTrees
		ld hl, #3e90, d, #28 : call makeTrees
		ld hl, #40e0, d, #20 : call makeTrees
		
mainLoop1c		
		ld a, #04
		dec a : jr z, mainLoop1e
		ld (mainLoop1c + 1), a
		
		; отключаем плашки
		; a != #00
		ld (IM2skip + 1), a
		
		; заполняем экран помехами
		ld b, 60 
ml11	call effectOne : halt : djnz ml11

		di
		ld de, #a000	; буфер для масок
		call copyScr

		ld a, #17 : out (#fd), a ; альт. экран, 7-я страница
		ld de, #c000
		call copyScr
		ei

		; Отображаем деревья эффектом
		ld a, #15 : out (#fd), a ; альт. экран, 7-я страница
		ld b, 50 
ml12	push bc 

		ld b, 10
ml13	push bc
		
		call DO_RND				
		ld d, a : ld e, 0 : call GET_ADR
		push hl : pop de
		res 6, h
		ld bc, #0020
		ldir
		
		pop bc
		djnz ml13

		halt 
		pop bc : djnz ml12

		; включаем плашки
		xor a : ld (IM2skip + 1), a

		; доп. пауза
		ld b, 190 : halt : djnz $-1	
		
		; cleanup buffer
		ld hl, #8000, bc, #17ff : call cleanup		

		jr mainLoop1
mainLoop1e
		; finalization begin
		; a = #00
		inc a : ld (IM2skip + 1), a
		
		dec b ; ld b, #ff 
ml21	call effectOne : halt : djnz ml21
		
		; a != #00
		call drawPlash
		xor a : call drawPlash
		di : halt
		
IM2		di : push af,bc,de,hl

		ld a, #15 : out (#fd), a
		
IM2skip
		ld a, #01
		or a : jr nz, IM2end
		
IM2C	ld a, #00 : inc a : ld (IM2C + 1), a
		
		and #07 : or a : jr nz, im21
		call drawPlash
		inc a : call drawPlash
im21

		ld a, r : cp 3	; частота "помех"
		jr nc, IM2end
		ld a, #1f : out (#fd), a
		call effectOne

IM2end		
        pop hl,de,bc,af
        ei : reti
	
		; очистка блока памяти (заливка нулем)
cleanup
		push hl : pop de : inc de : ld (hl), l : ldir : ret
		
		; готовим атрибуты экрана
prepareAttr	
		ld h,#d8, d,h, b,#03, (hl),#38 : inc e : ldir : dec e : ret
		;ld hl, #d800, de, #d801, bc, #2ff, (hl), #38 : ldir : ret
		
		; Копируем отрисованный экран в #c000 / #a000
copyScr
		ld hl, #8000, bc, #1800 : ldir : ret
		
		; рисуем плашку
		; a = 0 - первая плашка, a != - вторая
drawPlash
		or a : jr z, dPxy2
dpHL1	ld hl, CURSE1 : inc l : ld (dpHL1 + 1), hl
		ld bc, PL_BUF
		ld a, 03
		jr dPxy3

dPxy2		
dpHL2	ld hl, CURSE2 : inc l : ld (dpHL2 + 1), hl
		ld bc, PL_BUF + 5
		ld a, 12

dPxy3	ld (_dPs3 + 1), bc
		ld d, (hl) : inc h : ld e, (hl)
		push de

		ld (dP011 + 1), a
		add 2		
		dec l : ld e, (hl) : dec h : ld d, (hl)
		
		; восстанавливаем картинку под плашкой
		; a - кол-во знакомест
		; de - curse stage 
		ld (rP01 + 1) , a

		ld b, #08
rP00	push bc, de
		call GET_ADR
		push hl : pop de
		ld a, h : sub #20 : ld h, a
		
rP01	ld bc, #0000
		ldir
		
		pop de, bc 
		dec d
		djnz rP00
		; закончили восстановление
		
		; выбираем спрайт
		pop de : push de
		call GET_ADR
		; теперь в a - маска сдвига
_dPs3	ld hl, #0000	; адрес в спрайтах
		ld bc, #0020
		ld de, #007f
1		rla : jr c, 2f
		add hl, bc
		scf : rr d ; маска для первого байта
		rr e ; маска для последнего байта
		jr 1b
2
		
		ld a, d : ld (dPm1 + 1), a
		ld a, e : ld (dPm2 + 1), a
		
		pop de
		ld b, #08
		
dP01	push bc ; текущая строка
		push de ; xy
		
		push hl
		call GET_ADR
		ex de, hl
		pop hl	; buff
		
		; переносим строку
		push hl
		
		; первый байт строки - с маской
		ld a, (de)
dPm1	and #00
		or (hl) : ld (de), a : inc hl : inc de
		
dP011	ld a, #00	
		ldi : dec a : jr nz, $-3
		
		; последний байт строки - с маской
		ld a, (de)
dPm2	and #00
		or (hl) : ld (de), a

		pop hl : inc h 
		pop de : dec d
		
		pop bc
		djnz dP01
		ret 
	
; говноэффект - сменить?
effectOne
		ld c, #04
		push bc
		
		call DO_RND				
		ld d, a : ld e, 0 : call GET_ADR
		ex de, hl
		ld a, r : ld l, a : and #0f : ld h, a
		ld bc, #0020
		ldir
		
		pop bc
		dec c : jr nz, effectOne + 2
		ret
		
		; hl - откуда
		; d  - куда (X)
		; e  - начальный угол
makeTrees
		ld c, h
		ld h, #00
		ld e, l
		push de
		ld a, #05 : call LINEB
		pop hl
		
		;ld a, #05	; branches count

		; Рисуем ветки
		; hl - Начало
		; а - текущая итерация (0 - выход)
		; c - начальный угол
makeBranches
		dec a : cp #ff : ret z
		
		push af, bc
		call Branch
		
		pop bc, af : push af, bc
		call Branch
		
		pop bc, af
		; a - current iteration
		; c - текущий угол
Branch
		; store current iteration
		ld (BranchA + 1), a
		
		; increase length by sinus tbl
		ld ix, SINUS_TBL + #500
1		dec ixh : dec a : jr nz, 1b

		;ld ix, SINUS_TBL
		
		; random angle
		call DO_RND
		and #3f : sub #1f
		add c : ld c, a
		ld (BranchC + 1), a
		
		ld b, #00 : add ix, bc
		
		ld a, h : add (ix+0) : ld d, a ; синус
		
		; косинус с проверкой переполнения
		ld a, l : cp (ix+#40) : jr c, 1f
		add (ix+#40) : jr nc, 2f
		xor a : ld (BranchA + 1), a ; дальше не продолжаем
		dec a ; a=#ff
		jr 2f
1		add (ix+#40) : jr c, 2f
		xor a : ld (BranchA + 1), a ; дальше не продолжаем
2		ld e, a ; косинус

		push hl : push de
BranchA	ld a, #00
		call LINEB
BranchC	ld c, #00
		pop hl
		
		; do it reqursive
		call makeBranches
		pop hl : ret

; Толстая линия
; a - толщина в пикселях - 3		
LINEB
	push af
	add 3 : ld b, a
	ld a, e : cp l : jr z, lbc0	; x1=x2 - двигаем только Y
	
1	sub l : ld c, a
	ld a, d : sub h : cp c : jr c, lbc0
	
	; y1-y2 > x1 -x2 - двигаем X
	ld a, #3C ; inc a
	ld (lbc1), a
	xor a 
	jr lineb_cicle0
	
lbc0	
	ld a, #3D ; dec a
	ld (lbc1), a
	ld a, #01
lineb_cicle0
	ld (lbXY + 1), a, (lbXY + 1), a
lbc1 inc a : ld (lbXY + 2), a, (lbXY + 2), a

	ld a, #AE : ld (plot1) , a ; xor (hl)
lineb_cicle	
	call _linebB
	ld a, #B6 : ld (plot1) , a ; or (hl)
	djnz lineb_cicle
	
	;ld a, #AE : ld (plot1) , a ; xor (hl)
	;call _linebB
	pop af
	ret
_linebB
	push bc, hl, de
	call LINE
	pop de, hl
lbXY ld bc, #0000	
	ld a, d : add b : jr c, $+3 : ld d, a
	ld a, e : add c : jr c, $+3 : ld e, a
	ld a, h : add b : jr c, $+3 : ld h, a
	ld a, l : add c : jr c, $+3 : ld l, a

	pop bc
	ret
	
; Рисование линии. `Y` внизу! Ведется проверка `Y` < 0
; Координаты  концов  линии задаются в регистрах HL и DE (E и L - x, D и H - y)
LINE    
		LD     A,H    	; расчет смещений
        SUB    D
        JR     NC, LINE1
        EX     DE, HL   ; линия рисуется снизу вверх
        NEG           	; смена знака смещения
LINE1   LD     H,A    	; H=dy=¦y2-y1¦
        LD     A,L
        SUB    E
        LD     BC,#141C ; INC D [#14], INC E [#1C]
        JR     NC,LINE2
        INC    C        ; если x1<x2 то DEC E [#1D]
        NEG             ; смена знака смещения
LINE2   CP     H
        LD     L,A     ; L=dx=¦x2-x1¦
        JR     C,LINE3 ; если dx<dy то продолжение
        LD     L,H     ; замена dx<->dy
        LD     H,A
        LD     A,B     ; замена INC D <-> INC/DEC E
        LD     B,C
        LD     C,A
LINE3   LD     A,B     ; модификация кода
        LD     (LINE5),A
        LD     A,C
        LD     (LINE6),A
        LD     B,H     ; кол-во точек в линии
        LD     A,H
        INC    L
        INC    B
LINE4   CALL   PLOT    ;установка точки
LINE5   NOP
; изменение координаты с большим смещением
; направление зависит от знака смещения
        sub L
        JR NC, LINE7
LINE6   NOP
; изменение координаты с меньшим смещением
		add h
LINE7	djnz LINE4
		ret
		
PLOT    ex AF,AF'

		ld a, d : cp #c0 : jr c, $+4
		pop HL : ret ; y < 0

		push    hl      ;установка точки
        push    de
        call    GET_ADR
		res 6,h ; рисуем деревья с #8000
		
plot1	or (hl)
        ld      (hl),a
        ex      af,af'
        pop     de
        pop     hl
        ret

GET_ADR LD      A,#BF   ;расчет адреса в экране
        SUB     D
        LD      D,A
        SRL     A
        SCF
        RRA
        SRL     A
        XOR     D
        AND     #F8
        XOR     D
        LD      H,A
        LD      A,E
        RLCA
        RLCA
        RLCA
        XOR     D
        AND     #C7
        XOR     D
        RLCA
        RLCA
        LD      L,A
        LD      A,E
        AND     7
        INC     A
        LD      C,B     ;сохранение B
        LD      B,A
        LD      A,1
GETADR1 RRCA
        DJNZ    GETADR1
        LD      B,C     ;восстановление B
        LD      C,A     ;маска в c
		set 7,h
        RET
		
; Генерация таблицы синусов
SINMAKE
STACK_A EQU     #2D28
FP_TO_A EQU     #2DD5
SINCALC
        PUSH    DE
        PUSH    BC
        PUSH    DE
        LD      A,C
        CALL    STACK_A
        POP     DE
        LD      A,E
        CALL    STACK_A
        RST     #28     ;calc
        DB      #A3     ;stk_pi/2
        DB      #34,#40,#B0,#00,#40 ;#40
        DB      #05     ;divide
        DB      #04     ;multiply
        DB      #1F     ;sin
        DB      #04     ;multiply
        DB      #38     ;endcalc
        CALL    FP_TO_A
        JR      Z,$+4   ;->
        NEG             ; |
        POP     BC      ;<-
        ADD     A,B
        POP     DE
        LD      (DE),A
        INC     E
        JR      NZ,SINCALC
		
		; create 2 copy
		push de : pop hl : inc d
		ld bc, #0100 : push bc, hl : ldir : pop hl, bc : ldir
		
        RET

DO_RND  
		ld a,42 ;SEED is usually 0
		ld d,a
		add a,a
		add a,a
		add a,d
		inc a ;you may try also ADD A,7
		ld (DO_RND+1),a
		
        cp #c0
        jr nc, DO_RND
        ret

TEXT1	DB 'T' - 32, 'U' - 32, 'E' - 32, 'H' - 32, #00
TEXT2	DB 'B' - 32, 'E' - 32, '3' - 32, 'H' - 32, 'A' - 32, 'V' - 32, 'E' - 32, 'X' - 32, 'H' - 32, 'O' - 32, 'C' - 32, 'T' - 32, '6' - 32

		DISPLAY /d, 'Program length: ', $ - begin
eop		


		ALIGN #100
PL_BUF	BLOCK #800 ; Буфер хранения плашек
;PRT_RND	BLOCK #100

CURSE1	BLOCK #200 	
CURSE2	BLOCK #200 	

SINUS_TBL
		
		DISPLAY 'Data end: ', $
		
        ; build
		IF (_ERRORS == 0 && _WARNINGS == 0)
			LABELSLIST "user.l"
			SAVESNA "tlen.sna",begin
			SAVEBIN "tlen.C",begin,eop-begin
		ENDIF